# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.  # noqa: E501

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from akeyless.configuration import Configuration


class RenewCertificate(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'cert_issuer_name': 'str',
        'generate_key': 'bool',
        'item_id': 'int',
        'json': 'bool',
        'name': 'str',
        'token': 'str',
        'uid_token': 'str'
    }

    attribute_map = {
        'cert_issuer_name': 'cert-issuer-name',
        'generate_key': 'generate-key',
        'item_id': 'item-id',
        'json': 'json',
        'name': 'name',
        'token': 'token',
        'uid_token': 'uid-token'
    }

    def __init__(self, cert_issuer_name=None, generate_key=None, item_id=None, json=False, name=None, token=None, uid_token=None, local_vars_configuration=None):  # noqa: E501
        """RenewCertificate - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._cert_issuer_name = None
        self._generate_key = None
        self._item_id = None
        self._json = None
        self._name = None
        self._token = None
        self._uid_token = None
        self.discriminator = None

        if cert_issuer_name is not None:
            self.cert_issuer_name = cert_issuer_name
        if generate_key is not None:
            self.generate_key = generate_key
        if item_id is not None:
            self.item_id = item_id
        if json is not None:
            self.json = json
        if name is not None:
            self.name = name
        if token is not None:
            self.token = token
        if uid_token is not None:
            self.uid_token = uid_token

    @property
    def cert_issuer_name(self):
        """Gets the cert_issuer_name of this RenewCertificate.  # noqa: E501

        The name of the PKI certificate issuer  # noqa: E501

        :return: The cert_issuer_name of this RenewCertificate.  # noqa: E501
        :rtype: str
        """
        return self._cert_issuer_name

    @cert_issuer_name.setter
    def cert_issuer_name(self, cert_issuer_name):
        """Sets the cert_issuer_name of this RenewCertificate.

        The name of the PKI certificate issuer  # noqa: E501

        :param cert_issuer_name: The cert_issuer_name of this RenewCertificate.  # noqa: E501
        :type: str
        """

        self._cert_issuer_name = cert_issuer_name

    @property
    def generate_key(self):
        """Gets the generate_key of this RenewCertificate.  # noqa: E501

        Generate a new key as part of the certificate renewal  # noqa: E501

        :return: The generate_key of this RenewCertificate.  # noqa: E501
        :rtype: bool
        """
        return self._generate_key

    @generate_key.setter
    def generate_key(self, generate_key):
        """Sets the generate_key of this RenewCertificate.

        Generate a new key as part of the certificate renewal  # noqa: E501

        :param generate_key: The generate_key of this RenewCertificate.  # noqa: E501
        :type: bool
        """

        self._generate_key = generate_key

    @property
    def item_id(self):
        """Gets the item_id of this RenewCertificate.  # noqa: E501

        Certificate item id  # noqa: E501

        :return: The item_id of this RenewCertificate.  # noqa: E501
        :rtype: int
        """
        return self._item_id

    @item_id.setter
    def item_id(self, item_id):
        """Sets the item_id of this RenewCertificate.

        Certificate item id  # noqa: E501

        :param item_id: The item_id of this RenewCertificate.  # noqa: E501
        :type: int
        """

        self._item_id = item_id

    @property
    def json(self):
        """Gets the json of this RenewCertificate.  # noqa: E501

        Set output format to JSON  # noqa: E501

        :return: The json of this RenewCertificate.  # noqa: E501
        :rtype: bool
        """
        return self._json

    @json.setter
    def json(self, json):
        """Sets the json of this RenewCertificate.

        Set output format to JSON  # noqa: E501

        :param json: The json of this RenewCertificate.  # noqa: E501
        :type: bool
        """

        self._json = json

    @property
    def name(self):
        """Gets the name of this RenewCertificate.  # noqa: E501

        Certificate name  # noqa: E501

        :return: The name of this RenewCertificate.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this RenewCertificate.

        Certificate name  # noqa: E501

        :param name: The name of this RenewCertificate.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def token(self):
        """Gets the token of this RenewCertificate.  # noqa: E501

        Authentication token (see `/auth` and `/configure`)  # noqa: E501

        :return: The token of this RenewCertificate.  # noqa: E501
        :rtype: str
        """
        return self._token

    @token.setter
    def token(self, token):
        """Sets the token of this RenewCertificate.

        Authentication token (see `/auth` and `/configure`)  # noqa: E501

        :param token: The token of this RenewCertificate.  # noqa: E501
        :type: str
        """

        self._token = token

    @property
    def uid_token(self):
        """Gets the uid_token of this RenewCertificate.  # noqa: E501

        The universal identity token, Required only for universal_identity authentication  # noqa: E501

        :return: The uid_token of this RenewCertificate.  # noqa: E501
        :rtype: str
        """
        return self._uid_token

    @uid_token.setter
    def uid_token(self, uid_token):
        """Sets the uid_token of this RenewCertificate.

        The universal identity token, Required only for universal_identity authentication  # noqa: E501

        :param uid_token: The uid_token of this RenewCertificate.  # noqa: E501
        :type: str
        """

        self._uid_token = uid_token

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RenewCertificate):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RenewCertificate):
            return True

        return self.to_dict() != other.to_dict()
